//
//  AKNoteProperty.h
//  AudioKit
//
//  Created by Aurelius Prochazka on 9/22/12.
//  Copyright (c) 2012 Hear For Yourself. All rights reserved.
//

#import "AKConstant.h"

/** Note properties are properties of an instrument that are defined
 per each note generated by an instrument.
 */

@class AKNote;

@interface AKNoteProperty : AKConstant 

/// Optional pretty name for properties useful for debugging.
@property (nonatomic, strong) NSString *name;

/// Note this property belongs to
@property (nonatomic, strong) AKNote *note;

/// Internal reference number
@property (assign) int pValue;

+ (instancetype)duration;

@end
